/**
 * @Project: SanxiapayEpcs
 * @Title: HttpFileUtil.java
 * @Package com.hundsun.epay.epcs.bank.jsyh.portal.util
 * @Description: HttpFileUtil.java
 * @date 2015-7-3 下午04:29:01
 * @Copyright: 2015 www.hundsun.com All Rights Reserved.
 * @version V1.0.0.0 
 */
package com;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.HashMap;
import java.util.Map;

import com.hundsun.epay.pay.certkey.CertUtil;

/**
 * @ClassName HttpFileUtil
 * @Description HttpFileUtil
 * @date 2015-7-3
 */
public class HttpFileUtil {
	/**
	 * 
	 * @Method: getSyFile 
	 * @Description: 获取理财收益文件
	 * @param localFilePath
	 * @param checkDate
	 * @return
	 */
	public static String getFile(String remotePath,String localFilePath,String fileName,int timeout){
		 	InputStream in=null;
	        OutputStream out=null;
	        HttpURLConnection conn=null;
	        try {
	            //初始化连接
	            URL url=new URL(remotePath);
	            conn = (HttpURLConnection) url.openConnection();
	            conn.setRequestMethod("POST");
	            conn.setConnectTimeout(timeout);
	            conn.setReadTimeout(timeout);
	            conn.setDoInput(true);
	            conn.setDoOutput(true);
	            
	            //读取数据
	            if(conn.getResponseCode()==HttpURLConnection.HTTP_OK){
	                byte[] buffer=new byte[2048];
	                in = conn.getInputStream();
	                out=new FileOutputStream(new File(localFilePath,fileName));
	                int count=0;
	                int finished=0;
	                int size=conn.getContentLength();
	                while((count=in.read(buffer))!=-1){
	                    if(count!=0){
	                        out.write(buffer,0,count);
	                        finished+=count;
	                    }else{
	                        break;
	                    }
	                }
	            }else{
	            	return "999999|连接失败";
	            }
	        } catch (MalformedURLException e) {
	            return "999999|"+e.getMessage();
	        } catch (IOException e) {
	        	return "999999|无法获取文件";
	        }finally{
	            try {
	            	if(out!=null)
	            		out.close();
	            	if(in!=null)
	            		in.close();
	            	if(conn!=null)
	            		conn.disconnect();
	            } catch (IOException e) {
	                e.printStackTrace();
	            }
	        }
	        return "000000|成功";
	    }
	
	public static void main(String[] args) throws Exception{
		//下载份额
		Map<String, String> m = new HashMap<String, String>();
		m.put("partnerId","54adba8e1e0d4eabb42bab1bad29199d");
		m.put("checkDate","20150921");
		m.put("publicKeyCode", "00");
		m.put("charset", "UTF-8");
		String unSigncontent=BaseTest.sortParams(m);
		String signcontent=CertUtil.keyPairSign4Merchant(unSigncontent);
		String url="http://66.12.16.211:8080";
//		String url="http://66.0.34.336:9080";
		System.out.println(HttpFileUtil.getFile(url+"/epcs/download/mallFeInfo.htm?"+signcontent, "d:/epay","20151022.tar.Z",120000));
		//下载收益
		m = new HashMap<String, String>();
		m.put("partnerId","54adba8e1e0d4eabb42bab1bad29199d");
		m.put("checkDate","20151011");
		m.put("publicKeyCode", "00");
		m.put("charset", "UTF-8");
		unSigncontent=BaseTest.sortParams(m);
		signcontent=CertUtil.keyPairSign4Merchant(unSigncontent);
		url="http://66.12.16.211:8080";
//		System.out.println(HttpFileUtil.getFile(url+"/epcs/tunneled/mallSyInfo.htm?"+signcontent, "d:/epay","20150701.txt",120000));
	}
}
