/*
 * ļ:          HsConfigInfo.java
 * Ȩ@ 1997-2009 ݺ˾Ȩ
 * :           JDK1.4.2_08
 * ʱ:             05:06:40
 */
package com.config;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Iterator;
import java.util.Map;
import java.util.Properties;
import java.util.TreeMap;

/**
 * TODO: ļע
 * <p>
 * <p>
 * 汾:        
 * <p>
 * :           ڸ(zhangyg)
 * <p>
 * :           2010-11-3
 * <p>
 * ά:         ڸ(zhangyg)
 * <p>
 * С:        HundSun()
 * <p>
 * <p>
 */
public class ConfigIniImp implements IConfig{
	private File config;
	
	private Map<String,IField> global;
	private boolean isComment = false;
	private boolean isSyn = false;
	private final String SYM_COMMENT = "#";
	private final String SYM_SPLIT = "=";
	private final String SYM_FIELD_BEGIN = "[";
	private final String SYM_FIELD_END = "]";
	private final String SYM_DEF_FIELD = "SYSTEM";
	
	/**
	 * 
	 * @param cfgFile
	 * @param isComment
	 * @param isSyn
	 * @throws Exception
	 */
	public ConfigIniImp(File cfgFile, boolean isComment, boolean isSyn)throws Exception{
		if(cfgFile==null || !cfgFile.exists()){
			throw new Exception("!!!");
		}
		this.config = cfgFile;
		this.isComment = isComment;
		this.isSyn = isSyn;
		LoadCfg(config);
	}
	
	public ConfigIniImp(File cfgFile)throws Exception{
		this(cfgFile, false, false);
	}
	
	private static ConfigIniImp myobj;
	private static Properties ENV;
	
	public static synchronized IConfig createConfig(File cfgFile)throws Exception{
		if(myobj==null){
			System.out.println("Ϣ");
			myobj = new ConfigIniImp(cfgFile);
		}
		return myobj;
	}
	
	/**
	 * ȡϵͳ
	 * @return
	 * @throws Exception
	 */
	public static Properties getSysEnv() throws Exception {
		if(ENV == null){
			ENV = new Properties();
			String OS = System.getProperty("os.name").toLowerCase();
			Process p = null;
			if (OS.indexOf("windows") > -1) {
				p = Runtime.getRuntime().exec("cmd /c set");
			}
			else {
				p = Runtime.getRuntime().exec("sh -c set");
			}
			BufferedReader br = new BufferedReader(new InputStreamReader(p.getInputStream()));
			String line;
			while ((line = br.readLine()) != null) {
				int i = line.indexOf("=");
				if (i > -1) {
					String key = line.substring(0, i);
					String value = line.substring(i + 1);
					//System.out.println(key+" = ["+value+"]");
					ENV.setProperty(key, value);
				}
			}
		}
		return ENV;
	}
	/**
	 * ȡϵͳֵ
	 * @param key
	 * @return
	 * @throws Exception
	 */
	public static String getEnvVar(String key){
		try {
			if(ENV == null){
				ENV = getSysEnv();
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return ENV.getProperty(key);
	}
	
	private Map<String, IField> LoadCfg(File config){
		BufferedReader reader = null;
		try {
			reader = new BufferedReader(new FileReader(config));
			String sName = null;
			while(true){
				String sLine = reader.readLine();
				if(sLine == null){
					break;
				}
				sLine = trim(sLine);
				//жǷΪע,Ч
				if(sLine.startsWith(SYM_COMMENT) || sLine.trim().equals("")){
					continue;
				}
				//ע
				else{
					//жǷע,ȥע
					int index = sLine.indexOf(SYM_COMMENT);
					if(!isComment){
						if(index !=0 && index !=-1){
							sLine = sLine.substring(0, index);
						}
					}
					//жǷΪfield
					if(sLine.startsWith(SYM_FIELD_BEGIN) && sLine.endsWith(SYM_FIELD_END)){
						sName = sLine.substring(1, sLine.length()-1);
						if(global == null){
							global = new TreeMap<String, IField>();
						}
						global.put(sName, new FieldImp(sName));
					}
					//ȡֵ
					else{
						//ĬϽڵ(field֮ǰϢ)
						if(global == null){
							global = new TreeMap<String, IField>();
							sName = SYM_DEF_FIELD;
							global.put(SYM_DEF_FIELD, new FieldImp(SYM_DEF_FIELD));
						}
						int idx = sLine.indexOf(SYM_SPLIT);
						if(idx == -1){
							continue;
						}
						//ҵĵһȺŽвkeyvalueֵ
						String sKey = sLine.substring(0, idx);
						sKey = trim(sKey);
						String sValue = sLine.substring(idx+1);
						sValue = trim(sValue);
						//ʽ
						if(sValue.startsWith("${") && sValue.endsWith("}")){
							sValue = getExpValue(sValue);
						}
						
						IField field = global.get(sName);
						if(field ==null){
							setProperty(SYM_DEF_FIELD, sKey, sValue);
						}
						field.setParam(sKey, sValue);
					}
				}
			}
			
			reader.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
		finally{
			if(reader!=null){
				try {
					reader.close();
					reader = null;
				} catch (IOException ex) {
					ex.printStackTrace();
				}
			}
		}
		return global;
	}
	
	/**
	 * ȡϢ
	 * @param field ,ĬSYSTEM
	 * @param key ָڵϢ
	 * @return
	 */
	public String getProperty(String field, String key){
		if(isSyn || global == null){
			global = LoadCfg(config);
		}
		IField mField = global.get(field);
		if(mField == null){
			return "";
		}
		IField property = mField;
		
		String value = property.getParam(key);
		if(value == null){
			return "";
		}
		return value;
	}
	
	private void setProperty(String field, String key, String value){
		IField fieldobj = getField(field);
		if(fieldobj == null || fieldobj.getFieldSize()==0){
			return;
		}
		fieldobj.setParam(key, value);
	}
	
	/**
	 * ʽȡ(ݲֱ֧ƴ)
	 * @param sExp
	 * @return
	 */
	private String getExpValue(String sExp){
		String sIndex = "";
		if(sExp.startsWith("${") && sExp.endsWith("}")){
			int begin = sExp.indexOf("${")+2;
			int end = sExp.indexOf("}");
			sIndex = sExp.substring(begin, end);
		}
		return getValueByGloble(sIndex);
	}
	
	public String getValueByGloble(String key){
		Iterator<String> it = global.keySet().iterator();
		while(it.hasNext()){
			String sKey = (String)it.next();
			IField field = global.get(sKey);
			Iterator<String> index = field.getKeySet().iterator();
			while(index.hasNext()){
				String sIndex = trim((String)index.next());
				if(sIndex.equals(key)){
					return field.getParam(key);
				}
			}
		}
		return "";
	}
	
	public IField getField(String field){
		IField mField = global.get(field);
		if(mField == null){
			return null;
		}
		return mField;
	}
	
	public void close()throws Exception{
		config = null;
		if(global != null){
			global.clear();
			global = null;
		}
		myobj = null;
	}
	
	public Map<String, IField> getGlobal() {
		return global;
	}

	private String trim(String value){
		return value==null?"":value.trim();
	}
	
	public int getFieldCount() {
		return getGlobal().size();
	}

	public String getParam(String field, String key) {
		String tmp = getProperty(field, key);
		return tmp;
	}

	public String getParam(String command) {
		int index = command.indexOf(":");
		String value ="";
		if(index != -1){
			String field = command.substring(0,index);
			String key = command.substring(index+1);
			value = getProperty(field, key);
		}
		else{
			value = getValueByGloble(command);
		}
		return value;
	}
	
	
	public static void main(String[] args) {
		try {
			File file = new File("./config.ini");
			ConfigIniImp cfg = new ConfigIniImp(file);
			testPrintCfg(cfg);
			testGetValue(cfg);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public static void testGetValue(ConfigIniImp cfg){
		String key = "CsGmtSvr";
		String val = "CLIPORT";
		String command = key+":"+val;
		System.out.println("["+command+"]["+cfg.getParam(command)+"]");
		
		System.out.println("["+key+"]["+val+"]["+cfg.getParam(key, val)+"]");
		System.out.println("["+cfg.getFieldCount()+"]");
	}
	
	public static void testPrintCfg(ConfigIniImp cfg){
		try {
			Map<String, IField> fields = cfg.global;
			Iterator<String> it = fields.keySet().iterator();
			while(it.hasNext()){
				String fieldName = (String)it.next();
				System.out.println("["+fieldName+"]");
				IField field = cfg.getField(fieldName);
				Iterator<String> index = field.getKeySet().iterator();
				while(index.hasNext()){
					String sVar = index.next();
					System.out.println("\t["+sVar+"]["+cfg.getProperty(fieldName, sVar)+"]");
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public int getConfigType() throws Exception {
		return IConfig.FILE_TYPE_INI;
	}
}
