/**
 * @Project: SanxiapayEbs
 * @Title: RespPojoCheckAccout.java
 * @Description: 账户收支明细查询的响应POJO
 * @author fangchang fangchang@hundsun.com
 * @date 2014-4-24 上午11:21:30
 * @Copyright: 2014 www.hundsun.com All Rights Reserved.
 * @version V1.0.0.0 
 */


package pojo.resp;

import java.util.List;

/**
 * @ClassName RespPojoCheckAccout
 * @Description 对账信息请求
 * @author guchao11233@hundsun.com
 * @date 2014-11-6
 */
@SuppressWarnings("serial")
public class RespPojoCheckAccout extends BaseBusiRespPojo {

	/**
	 * 默认子账户交易明细
	 */
	private List<RespPojoCheckAccoutData> respPojoCheckAccoutData;  
	
	/**
     * 总记录数
     */
    private int totalRows;
	
    /**
     * 每页多少条
     */
    private int pageSize;

    /**
     * 当前第几页
     */
    private int currentPage;
    
    /**
     * 总页码数
     */
    private int totalPages;    
    /**
     * 是否有下一页
     */
    private int hasNext;
    /**
     * 是否有上一页
     */
    private int hasPrevious;
    
    /**
     * 本页开始的记录位置
     */
    private int               pageStartRow;
    /**
     * 本页结束的记录位置
     */
    private int               pageEndRow;
    
	/** 
	 * @return respPojoCheckAccoutData 
	 */
	
	public List<RespPojoCheckAccoutData> getRespPojoCheckAccoutData() {
		return respPojoCheckAccoutData;
	}


	/** 
	 * @param respPojoCheckAccoutData 要设置的 respPojoCheckAccoutData 
	 */
	
	public void setRespPojoCheckAccoutData(List<RespPojoCheckAccoutData> respPojoCheckAccoutData) {
		this.respPojoCheckAccoutData = respPojoCheckAccoutData;
	}


	/** 
	 * @return totalRows 
	 */
	public int getTotalRows() {
		return totalRows;
	}


	/** 
	 * @param totalRows 要设置的 totalRows 
	 */
	public void setTotalRows(int totalRows) {
		this.totalRows = totalRows;
	}


	/** 
	 * @return pageSize 
	 */
	public int getPageSize() {
		return pageSize;
	}


	/** 
	 * @param pageSize 要设置的 pageSize 
	 */
	public void setPageSize(int pageSize) {
		this.pageSize = pageSize;
	}


	/** 
	 * @return currentPage 
	 */
	public int getCurrentPage() {
		return currentPage;
	}


	/** 
	 * @param currentPage 要设置的 currentPage 
	 */
	public void setCurrentPage(int currentPage) {
		this.currentPage = currentPage;
	}


	/** 
	 * @return totalPages 
	 */
	public int getTotalPages() {
		return totalPages;
	}


	/** 
	 * @param totalPages 要设置的 totalPages 
	 */
	public void setTotalPages(int totalPages) {
		this.totalPages = totalPages;
	}


	/** 
	 * @return hasNext 
	 */
	public int getHasNext() {
		return hasNext;
	}


	/** 
	 * @param hasNext 要设置的 hasNext 
	 */
	public void setHasNext(int hasNext) {
		this.hasNext = hasNext;
	}


	/** 
	 * @return hasPrevious 
	 */
	public int getHasPrevious() {
		return hasPrevious;
	}


	/** 
	 * @param hasPrevious 要设置的 hasPrevious 
	 */
	public void setHasPrevious(int hasPrevious) {
		this.hasPrevious = hasPrevious;
	}


	/** 
	 * @return pageStartRow 
	 */
	public int getPageStartRow() {
		return pageStartRow;
	}


	/** 
	 * @param pageStartRow 要设置的 pageStartRow 
	 */
	public void setPageStartRow(int pageStartRow) {
		this.pageStartRow = pageStartRow;
	}


	/** 
	 * @return pageEndRow 
	 */
	public int getPageEndRow() {
		return pageEndRow;
	}


	/** 
	 * @param pageEndRow 要设置的 pageEndRow 
	 */
	public void setPageEndRow(int pageEndRow) {
		this.pageEndRow = pageEndRow;
	}


	
	
}
