package com.hundsun.epay.pay;

import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;

import org.apache.log4j.Level;
import org.apache.log4j.Logger;

public class PropertiesUtil {
	public static String fileName="/conf/cert-key.properties";

	public static String merchantPersonalKey="";
	public static String merchantPrivateKeyFile="";
	public static String merchantPrivateKeyPassword="";
	public static String jschinaPrivateKeyFile="";
	public static String jschinaPrivateKeyPassword="";
	public static String jschinaPublicKeyFile="";
	
	static {  
        Properties p = new Properties();  
        try {  
            InputStream in = PropertiesUtil.class.getResourceAsStream(fileName);//这里有人用new FileInputStream(fileName),不过这种方式找不到配置文件。有人说是在classes下，我调过了，不行。  
            p.load(in);  
            in.close();  
            
            if(p.containsKey("merchant.personalKey")){  
            	merchantPersonalKey = p.getProperty("merchant.personalKey");  
            }             
            if(p.containsKey("jschina.privateKeyFile")){  
                jschinaPrivateKeyFile = p.getProperty("jschina.privateKeyFile");  
            }  
            if(p.containsKey("jschina.privateKeyFile.privateKeyPassword")){  
                jschinaPrivateKeyPassword = p.getProperty("jschina.privateKeyFile.privateKeyPassword");  
            }  
            if(p.containsKey("merchant.privateKeyFile")){  
            	merchantPrivateKeyFile = p.getProperty("merchant.privateKeyFile");  
            }  
            if(p.containsKey("merchant.privateKeyFile.privateKeyPassword")){  
            	merchantPrivateKeyPassword = p.getProperty("merchant.privateKeyFile.privateKeyPassword");  
            }  
            if(p.containsKey("jschina.publicKeyFile")){  
                jschinaPublicKeyFile = p.getProperty("jschina.publicKeyFile");  
            }  
        } catch (IOException ex) {  
        	
            Logger.getLogger(PropertiesUtil.class.getName()).log(Level.ERROR, null, ex);  
        }  
    }

	
}
